<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\Pracovisko\PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Contracts\Support\Jsonable;
use InvalidArgumentException;
use JsonSerializable;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhPalivaEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\EmisnySystemEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla;
use Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\DataTableRowContract;

/**
 * Class PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidlaDataTableRow
 *
 * @package Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\Pracovisko\PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla
 */
final class PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidlaDataTableRow implements DataTableRowContract, Arrayable, Jsonable, JsonSerializable
{
    /**
     * @var int
     */
    private int $spolu = 0;

    /**
     * @var \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhPalivaEnum
     */
    private DruhPalivaEnum $druhPaliva;

    /**
     * @var \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\EmisnySystemEnum
     */
    private EmisnySystemEnum $emisnySystem;

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhPalivaEnum   $druhPaliva
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\EmisnySystemEnum $emisnySystem
     */
    public function __construct(DruhPalivaEnum $druhPaliva, EmisnySystemEnum $emisnySystem)
    {
        $this->druhPaliva = $druhPaliva;
        $this->emisnySystem = $emisnySystem;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla $pocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla
     *
     * @return $this
     */
    public function add(PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla $pocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla): PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidlaDataTableRow
    {
        if (false === $this->druhPaliva->equal($pocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla->druhPaliva())) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa druh paliva %s, vstupny atribut obsahuje druh paliva %s',
                $this->druhPaliva->value,
                $pocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla->druhPaliva()->value
            ));
        }

        if (false === $this->emisnySystem->equal($pocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla->emisnySystem())) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa druh emisneho systemu %s, vstupny atribut obsahuje druh emisneho systemu %s',
                $this->emisnySystem()->value,
                $pocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla->emisnySystem()->value
            ));
        }

        $this->spolu += $pocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla->pocet();

        return $this;
    }

    /**
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhPalivaEnum
     */
    public function druhPaliva(): DruhPalivaEnum
    {
        return $this->druhPaliva;
    }

    /**
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\EmisnySystemEnum
     */
    public function emisnySystem(): EmisnySystemEnum
    {
        return $this->emisnySystem;
    }

    /**
     * @param int $options
     *
     * @return string
     */
    public function toJson($options = 0): string
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'label' => sprintf('%s/%s', $this->druhPaliva->label(), $this->emisnySystem->label()),
            'data' => [
                'spolu' => $this->spolu,
            ],
        ];
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array
    {
        return $this->toArray();
    }
}
